if SERVER then
   AddCSLuaFile( "shared.lua" )
   resource.AddFile("materials/icon_blazer.png")
end

SWEP.HoldType              = "ar2"

if CLIENT then
   SWEP.PrintName          = "Blazer"
   SWEP.Slot               = 6

   SWEP.ViewModelFlip      = false
   SWEP.ViewModelFOV       = 54
   
   SWEP.EquipMenuData = {
      type = "item_weapon",
      desc = "2 Shots.\n\nCauses victim to burn and run around \nuncontrollably while screaming. NOTE that you will \nbe damaged a bit on equipt."
   };

   SWEP.Icon = "vgui/ttt/icon_blazer.png"
end

SWEP.Base                  = "weapon_tttbase"

SWEP.Primary.Recoil        = 3
SWEP.Primary.Damage        = 0
SWEP.Primary.Delay         = 2
SWEP.Primary.Cone          = 0
SWEP.Primary.ClipSize      = 2
SWEP.Primary.Automatic     = false
SWEP.Primary.DefaultClip   = 2
SWEP.Primary.ClipMax       = 2
SWEP.Primary.Ammo          = "none"
SWEP.AmmoEnt               = "none"

SWEP.NeRound               = false
SWEP.OldFOV                = 75

SWEP.UseHands              = true
SWEP.ViewModel             = Model("models/weapons/cstrike/c_snip_scout.mdl")
SWEP.WorldModel            = Model("models/weapons/w_snip_scout.mdl")

SWEP.Kind = WEAPON_EQUIP1
SWEP.WeaponID = AMMO_RIFLE
SWEP.CanBuy = {ROLE_TRAITOR}
SWEP.LimitedStock = true

SWEP.IronSightsPos         = Vector(-5.95, -1, 4.799)
SWEP.IronSightsAng         = Vector(0, 0, 0)

function SWEP:Deploy()
  self.OldFOV = self.Owner:GetFOV()
  self.Weapon:SetColor(Color(255, 255, 255, 255))
  if self.Weapon:IsOnFire() then if SERVER then self.Weapon:Extinguish() end end
  if self.Owner:Alive() then self.Weapon:Ignite(0.2, 0) end
  return true
end

function SWEP:Holster()
  if self.Owner:IsValid() and self.Owner:Alive() then self.Owner:SetFOV(self.OldFOV, 0) end
  if self.Weapon:IsOnFire() then if SERVER then self.Weapon:Extinguish() end end
  return true
end

function SWEP:PrimaryAttack()
  if !self:CanPrimaryAttack() then return end
  local cone = self.Primary.Cone
  local num = 1

  local bullet = {}
  bullet.Num    = num
  bullet.Src    = self.Owner:GetShootPos()
  bullet.Dir    = self.Owner:GetAimVector()
  bullet.Spread = Vector( cone, cone, 0 )
  bullet.Tracer = 1
  bullet.Force	= 1
  bullet.Damage = 0
  bullet.TracerName = "Explosion"
   
  local bulletu = {}
  bulletu.Num    = num
  bulletu.Src    = self.Owner:GetShootPos()
  bulletu.Dir    = self.Owner:GetAimVector()
  bulletu.Spread = Vector( cone, cone, 0 )
  bulletu.Tracer = 1
  bulletu.Force  = 0
  bulletu.Damage = 0
  bulletu.TracerName = "Tracer"
   
  bullet.Callback = function(att, tr)
    if SERVER or (CLIENT and IsFirstTimePredicted()) then
      local ent = tr.Entity
      if SERVER and ent:IsPlayer() and ent:Alive() and self.NeRound == false then
	    if ent:HasGodMode() then ent:GodDisable() end
        ent:Ignite(9999, 30)
        if ent:Alive() then
		  if SERVER then ent:EmitSound("ambient/fire/ignite.wav") end
		    ent:SetLaggedMovementValue(2.5)
		    local igniteSays = {"Phew, that was a close one!", "Shit, I felt like a potato in a oven!", "Is it me, or was it just hot in here?"}
		    local fTimerName = "fTimer"..math.random(1, 10000)
		    local hasJumped = false
		    local inflictWep = ents.Create("weapon_ttt_blazer")
		    local entHealth = ent:Health()
		    timer.Create(fTimerName, 1, entHealth+5/5, function()
		      if ent:Alive() and ent:IsOnFire() and att:Alive() and ent:Team() == 1 and self.NeRound == false then
                ent:ConCommand("+forward")
		        ent:ConCommand("+right")
		        if ent:OnGround() and ent:Alive() and hasJumped == false then
			      ent:ConCommand("+jump")
			      hasJumped = true
			    else
			      ent:ConCommand("-jump")
			      hasJumped = false
			    end
			    if timer.RepsLeft(fTimerName) == 0 then
			      ent:ConCommand("-forward")
		          ent:ConCommand("-right")
			      ent:ConCommand("-jump")
			      ent:SetLaggedMovementValue(1)
			      if ent:Alive() then 
			        ent:Extinguish()
				    timer.Simple(1, function() if ent:Alive() and ent:Team() == 1 then ent:Say(igniteSays[math.random(1, 3)]) end end)
			      end
			    end
			  else 
			    timer.Simple(2, function()
			      if att:Alive() and !ent:Alive() then
				    att:DoAnimationEvent(ACT_GMOD_TAUNT_LAUGH, 1618)
				    att:EmitSound("vo/Citadel/br_laugh01.wav", 70, 70, 1, CHAN_AUTO)
			      end
			    end) 
			    ent:ConCommand("-forward")
		        ent:ConCommand("-right")
			    ent:ConCommand("-jump")
				ent:Extinguish()
			    ent:SetLaggedMovementValue(1)
			    timer.Simple(1, function() if ent:Alive() and ent:Team() == 1 then ent:Say(igniteSays[math.random(1, 3)]) end end)
			    if timer.Exists(fTimerName) then timer.Destroy(fTimerName) end
			  end
		    end)
		  end
        end
		hook.Add( "TTTEndRound", "BlazeRoundChecker", function( result )
          if result == WIN_TRAITOR or result == WIN_INNOCENT or result == WIN_TIMELIMIT then
	        self.NeRound = true
          end
        end)
    end
  end
  
  if self.Owner:IsPlayer() then
    self.Owner:LagCompensation(true)
  end
  
  self.Owner:FireBullets( bulletu )
  self.Owner:FireBullets( bullet )
  
  if SERVER then
    self:TakePrimaryAmmo( 1 )
  end
  
  if self.Owner:IsPlayer() then
    self.Owner:LagCompensation(false)
  end
  
  self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
end

function SWEP:SecondaryAttack()
  if self:GetNextSecondaryFire() > CurTime() then return end
    if SERVER then
    if self.Owner:GetFOV() >= self.OldFOV then
      self.Owner:SetFOV(50, 0.5)
    else
      self.Owner:SetFOV(self.OldFOV, 0.3)
    end
  end
  self:SetNextSecondaryFire( CurTime() + 0.2)
end

function SWEP:PreDrop()
  self.Owner:SetFOV(self.OldFOV, 0)
  self.Weapon:Ignite(999)
  self.Weapon:SetColor(Color(255, 140, 0, 255))
end
